Subject: bug#49505: 28.0.50; Multiple launchers in GNOME

From: Peter Oliver <[email-masked]>
Date: Tue, 10 Aug 2021 22:22:03 +0100 (BST)

On Sat, 10 Jul 2021, Lars Ingebrigtsen wrote:

> Manuel Uberti <[email-masked]> writes:
>
>> I built Emacs master (commit: 3fa711c11d1497418fdf8a866b7ba52dd3b00e0e)
>> and now I see two launchers (.desktop files) in GNOME:
>>
>> - Emacs
>> - Emacs (Client)
>>
>> The first one is the one I added to my favourites in GNOME, thus it's
>> the launcher I've always used in my GNOME dash panel to launch
>> Emacs. See attachment 1.png.
>>
>> However, this launcher now always spawns a new Emacs (Client),
>> resulting in two Emacs icons in my GNOME dash. See attachment 2.png.
>
> I think this might be due to the recent changed here by Peter (added to
> the CCs).

Yes, I think this will be caused by the fix to bug 49259.

> For now, I see that by doing the following I only get one launcher in the Dash 
> panel:
> 
> - Add Emacs (Client) to favourites
> - Right-click on it
> - Select New Instance
> 
> I don't know if this is what Peter had in mind for the user to do, though.

Pretty much, yes.  You should be able to use emacsclient.desktop for everything.  By the way, if you’re launching Emacs for the first time in a session, you shouldn’t need to right-click and select New Instance.  Left clicking should cause a new instance to run if there is no existing instance.

The duplicate icons are annoying, though.

It’s my view that we should provide only one .desktop file (namely emacsclient.desktop, renamed to emacs.desktop).  However, when this was discussed at <https://lists.gnu.org/archive/html/emacs-devel/2021-05/msg00648.html>, consensus was not reached.

It’s my suspicion that implementing the Freedesktop.org startup notification protocol in emacsclient, as proposed in bug 49504, would also cause this issue to go away, because the desktop would be able to identify which window was opened as a result of clicking on which icon.  However, that seems controversial, too.

I’m not sure what else to suggest.  We can revert the fix to 49259 (or, more sensibly, remove StartupWMClass from emacsclient.desktop entirely), but that doesn’t really help, since it’d cause the opposite problem that people who favourite “Emacs (Client)” would end up with a duplicate “Emacs” icon.

-- 
Peter Oliver